<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">

<html>

<head>

<meta http-equiv="content-type" content="text/html; charset=iso-8859-1">

<title>Debian Policy Manual - Footnotes</title>

<link href="index.html" rel="start">
<link href=".html" rel="prev">
<link href=".html" rel="next">
<link href="index.html#contents" rel="contents">
<link href="index.html#copyright" rel="copyright">
<link href="ch-scope.html" rel="chapter" title="1 About this manual">
<link href="ch-archive.html" rel="chapter" title="2 The Debian Archive">
<link href="ch-binary.html" rel="chapter" title="3 Binary packages">
<link href="ch-source.html" rel="chapter" title="4 Source packages">
<link href="ch-controlfields.html" rel="chapter" title="5 Control files and their fields">
<link href="ch-maintainerscripts.html" rel="chapter" title="6 Package maintainer scripts and installation procedure">
<link href="ch-relationships.html" rel="chapter" title="7 Declaring relationships between packages">
<link href="ch-sharedlibs.html" rel="chapter" title="8 Shared libraries">
<link href="ch-opersys.html" rel="chapter" title="9 The Operating System">
<link href="ch-files.html" rel="chapter" title="10 Files">
<link href="ch-customized-programs.html" rel="chapter" title="11 Customized programs">
<link href="ch-docs.html" rel="chapter" title="12 Documentation">
<link href="ap-pkg-scope.html" rel="appendix" title="A Introduction and scope of these appendices">
<link href="ap-pkg-binarypkg.html" rel="appendix" title="B Binary packages (from old Packaging Manual)">
<link href="ap-pkg-sourcepkg.html" rel="appendix" title="C Source packages (from old Packaging Manual)">
<link href="ap-pkg-controlfields.html" rel="appendix" title="D Control files and their fields (from old Packaging Manual)">
<link href="ap-pkg-conffiles.html" rel="appendix" title="E Configuration file handling (from old Packaging Manual)">
<link href="ap-pkg-alternatives.html" rel="appendix" title="F Alternative versions of an interface - update-alternatives (from old Packaging Manual)">
<link href="ap-pkg-diversions.html" rel="appendix" title="G Diversions - overriding a package's version of a file (from old Packaging Manual)">
<link href="ch-scope.html#s1.1" rel="section" title="1.1 Scope">
<link href="ch-scope.html#s1.2" rel="section" title="1.2 New versions of this document">
<link href="ch-scope.html#s-authors" rel="section" title="1.3 Authors and Maintainers">
<link href="ch-scope.html#s-related" rel="section" title="1.4 Related documents">
<link href="ch-scope.html#s-definitions" rel="section" title="1.5 Definitions">
<link href="ch-archive.html#s-dfsg" rel="section" title="2.1 The Debian Free Software Guidelines">
<link href="ch-archive.html#s-sections" rel="section" title="2.2 Archive areas">
<link href="ch-archive.html#s-pkgcopyright" rel="section" title="2.3 Copyright considerations">
<link href="ch-archive.html#s-subsections" rel="section" title="2.4 Sections">
<link href="ch-archive.html#s-priorities" rel="section" title="2.5 Priorities">
<link href="ch-binary.html#s3.1" rel="section" title="3.1 The package name">
<link href="ch-binary.html#s-versions" rel="section" title="3.2 The version of a package">
<link href="ch-binary.html#s-maintainer" rel="section" title="3.3 The maintainer of a package">
<link href="ch-binary.html#s-descriptions" rel="section" title="3.4 The description of a package">
<link href="ch-binary.html#s-dependencies" rel="section" title="3.5 Dependencies">
<link href="ch-binary.html#s-virtual_pkg" rel="section" title="3.6 Virtual packages">
<link href="ch-binary.html#s3.7" rel="section" title="3.7 Base system">
<link href="ch-binary.html#s3.8" rel="section" title="3.8 Essential packages">
<link href="ch-binary.html#s-maintscripts" rel="section" title="3.9 Maintainer Scripts">
<link href="ch-source.html#s-standardsversion" rel="section" title="4.1 Standards conformance">
<link href="ch-source.html#s-pkg-relations" rel="section" title="4.2 Package relationships">
<link href="ch-source.html#s4.3" rel="section" title="4.3 Changes to the upstream sources">
<link href="ch-source.html#s-dpkgchangelog" rel="section" title="4.4 Debian changelog: debian/changelog">
<link href="ch-source.html#s-dpkgcopyright" rel="section" title="4.5 Copyright: debian/copyright">
<link href="ch-source.html#s4.6" rel="section" title="4.6 Error trapping in makefiles">
<link href="ch-source.html#s-timestamps" rel="section" title="4.7 Time Stamps">
<link href="ch-source.html#s-restrictions" rel="section" title="4.8 Restrictions on objects in source packages">
<link href="ch-source.html#s-debianrules" rel="section" title="4.9 Main building script: debian/rules">
<link href="ch-source.html#s-substvars" rel="section" title="4.10 Variable substitutions: debian/substvars">
<link href="ch-source.html#s-debianwatch" rel="section" title="4.11 Optional upstream source location: debian/watch">
<link href="ch-source.html#s-debianfiles" rel="section" title="4.12 Generated files list: debian/files">
<link href="ch-source.html#s-embeddedfiles" rel="section" title="4.13 Convenience copies of code">
<link href="ch-source.html#s-readmesource" rel="section" title="4.14 Source package handling: debian/README.source">
<link href="ch-controlfields.html#s-controlsyntax" rel="section" title="5.1 Syntax of control files">
<link href="ch-controlfields.html#s-sourcecontrolfiles" rel="section" title="5.2 Source package control files -- debian/control">
<link href="ch-controlfields.html#s-binarycontrolfiles" rel="section" title="5.3 Binary package control files -- DEBIAN/control">
<link href="ch-controlfields.html#s-debiansourcecontrolfiles" rel="section" title="5.4 Debian source control files -- .dsc">
<link href="ch-controlfields.html#s-debianchangesfiles" rel="section" title="5.5 Debian changes files -- .changes">
<link href="ch-controlfields.html#s-controlfieldslist" rel="section" title="5.6 List of fields">
<link href="ch-controlfields.html#s5.7" rel="section" title="5.7 User-defined fields">
<link href="ch-controlfields.html#s-obsolete-control-data-fields" rel="section" title="5.8 Obsolete fields">
<link href="ch-maintainerscripts.html#s6.1" rel="section" title="6.1 Introduction to package maintainer scripts">
<link href="ch-maintainerscripts.html#s-idempotency" rel="section" title="6.2 Maintainer scripts idempotency">
<link href="ch-maintainerscripts.html#s-controllingterminal" rel="section" title="6.3 Controlling terminal for maintainer scripts">
<link href="ch-maintainerscripts.html#s-exitstatus" rel="section" title="6.4 Exit status">
<link href="ch-maintainerscripts.html#s-mscriptsinstact" rel="section" title="6.5 Summary of ways maintainer scripts are called">
<link href="ch-maintainerscripts.html#s-unpackphase" rel="section" title="6.6 Details of unpack phase of installation or upgrade">
<link href="ch-maintainerscripts.html#s-configdetails" rel="section" title="6.7 Details of configuration">
<link href="ch-maintainerscripts.html#s-removedetails" rel="section" title="6.8 Details of removal and/or configuration purging">
<link href="ch-relationships.html#s-depsyntax" rel="section" title="7.1 Syntax of relationship fields">
<link href="ch-relationships.html#s-binarydeps" rel="section" title="7.2 Binary Dependencies - Depends, Recommends, Suggests, Enhances, Pre-Depends">
<link href="ch-relationships.html#s-breaks" rel="section" title="7.3 Packages which break other packages - Breaks">
<link href="ch-relationships.html#s-conflicts" rel="section" title="7.4 Conflicting binary packages - Conflicts">
<link href="ch-relationships.html#s-virtual" rel="section" title="7.5 Virtual packages - Provides">
<link href="ch-relationships.html#s-replaces" rel="section" title="7.6 Overwriting files and replacing packages - Replaces">
<link href="ch-relationships.html#s-sourcebinarydeps" rel="section" title="7.7 Relationships between source and binary packages - Build-Depends, Build-Depends-Indep, Build-Conflicts, Build-Conflicts-Indep">
<link href="ch-relationships.html#s-built-using" rel="section" title="7.8 Additional source packages used to build the binary - Built-Using">
<link href="ch-sharedlibs.html#s-sharedlibs-runtime" rel="section" title="8.1 Run-time shared libraries">
<link href="ch-sharedlibs.html#s-sharedlibs-support-files" rel="section" title="8.2 Shared library support files">
<link href="ch-sharedlibs.html#s-sharedlibs-static" rel="section" title="8.3 Static libraries">
<link href="ch-sharedlibs.html#s-sharedlibs-dev" rel="section" title="8.4 Development files">
<link href="ch-sharedlibs.html#s-sharedlibs-intradeps" rel="section" title="8.5 Dependencies between the packages of the same library">
<link href="ch-sharedlibs.html#s-sharedlibs-depends" rel="section" title="8.6 Dependencies between the library and other packages">
<link href="ch-opersys.html#s9.1" rel="section" title="9.1 File system hierarchy">
<link href="ch-opersys.html#s9.2" rel="section" title="9.2 Users and groups">
<link href="ch-opersys.html#s-sysvinit" rel="section" title="9.3 System run levels and init.d scripts">
<link href="ch-opersys.html#s9.4" rel="section" title="9.4 Console messages from init.d scripts">
<link href="ch-opersys.html#s-cron-jobs" rel="section" title="9.5 Cron jobs">
<link href="ch-opersys.html#s-menus" rel="section" title="9.6 Menus">
<link href="ch-opersys.html#s-mime" rel="section" title="9.7 Multimedia handlers">
<link href="ch-opersys.html#s9.8" rel="section" title="9.8 Keyboard configuration">
<link href="ch-opersys.html#s9.9" rel="section" title="9.9 Environment variables">
<link href="ch-opersys.html#s-doc-base" rel="section" title="9.10 Registering Documents using doc-base">
<link href="ch-opersys.html#s-alternateinit" rel="section" title="9.11 Alternate init systems">
<link href="ch-files.html#s-binaries" rel="section" title="10.1 Binaries">
<link href="ch-files.html#s-libraries" rel="section" title="10.2 Libraries">
<link href="ch-files.html#s10.3" rel="section" title="10.3 Shared libraries">
<link href="ch-files.html#s-scripts" rel="section" title="10.4 Scripts">
<link href="ch-files.html#s10.5" rel="section" title="10.5 Symbolic links">
<link href="ch-files.html#s10.6" rel="section" title="10.6 Device files">
<link href="ch-files.html#s-config-files" rel="section" title="10.7 Configuration files">
<link href="ch-files.html#s10.8" rel="section" title="10.8 Log files">
<link href="ch-files.html#s-permissions-owners" rel="section" title="10.9 Permissions and owners">
<link href="ch-files.html#s-filenames" rel="section" title="10.10 File names">
<link href="ch-customized-programs.html#s-arch-spec" rel="section" title="11.1 Architecture specification strings">
<link href="ch-customized-programs.html#s11.2" rel="section" title="11.2 Daemons">
<link href="ch-customized-programs.html#s11.3" rel="section" title="11.3 Using pseudo-ttys and modifying wtmp, utmp and lastlog">
<link href="ch-customized-programs.html#s11.4" rel="section" title="11.4 Editors and pagers">
<link href="ch-customized-programs.html#s-web-appl" rel="section" title="11.5 Web servers and applications">
<link href="ch-customized-programs.html#s-mail-transport-agents" rel="section" title="11.6 Mail transport, delivery and user agents">
<link href="ch-customized-programs.html#s11.7" rel="section" title="11.7 News system configuration">
<link href="ch-customized-programs.html#s11.8" rel="section" title="11.8 Programs for the X Window System">
<link href="ch-customized-programs.html#s-perl" rel="section" title="11.9 Perl programs and modules">
<link href="ch-customized-programs.html#s-emacs" rel="section" title="11.10 Emacs lisp programs">
<link href="ch-customized-programs.html#s11.11" rel="section" title="11.11 Games">
<link href="ch-docs.html#s12.1" rel="section" title="12.1 Manual pages">
<link href="ch-docs.html#s12.2" rel="section" title="12.2 Info documents">
<link href="ch-docs.html#s-docs-additional" rel="section" title="12.3 Additional documentation">
<link href="ch-docs.html#s12.4" rel="section" title="12.4 Preferred documentation formats">
<link href="ch-docs.html#s-copyrightfile" rel="section" title="12.5 Copyright information">
<link href="ch-docs.html#s12.6" rel="section" title="12.6 Examples">
<link href="ch-docs.html#s-changelogs" rel="section" title="12.7 Changelog files">
<link href="ap-pkg-binarypkg.html#s-pkg-bincreating" rel="section" title="B.1 Creating package files - dpkg-deb">
<link href="ap-pkg-binarypkg.html#s-pkg-controlarea" rel="section" title="B.2 Package control information files">
<link href="ap-pkg-binarypkg.html#s-pkg-controlfile" rel="section" title="B.3 The main control information file: control">
<link href="ap-pkg-binarypkg.html#sB.4" rel="section" title="B.4 Time Stamps">
<link href="ap-pkg-sourcepkg.html#s-pkg-sourcetools" rel="section" title="C.1 Tools for processing source packages">
<link href="ap-pkg-sourcepkg.html#s-pkg-sourcetree" rel="section" title="C.2 The Debian package source tree">
<link href="ap-pkg-sourcepkg.html#s-pkg-sourcearchives" rel="section" title="C.3 Source packages as archives">
<link href="ap-pkg-sourcepkg.html#sC.4" rel="section" title="C.4 Unpacking a Debian source package without dpkg-source">
<link href="ap-pkg-controlfields.html#sD.1" rel="section" title="D.1 Syntax of control files">
<link href="ap-pkg-controlfields.html#sD.2" rel="section" title="D.2 List of fields">
<link href="ap-pkg-conffiles.html#sE.1" rel="section" title="E.1 Automatic handling of configuration files by dpkg">
<link href="ap-pkg-conffiles.html#sE.2" rel="section" title="E.2 Fully-featured maintainer script configuration handling">
<link href="ch-archive.html#s-main" rel="subsection" title="2.2.1 The main archive area">
<link href="ch-archive.html#s-contrib" rel="subsection" title="2.2.2 The contrib archive area">
<link href="ch-archive.html#s-non-free" rel="subsection" title="2.2.3 The non-free archive area">
<link href="ch-binary.html#s3.2.1" rel="subsection" title="3.2.1 Version numbers based on dates">
<link href="ch-binary.html#s-synopsis" rel="subsection" title="3.4.1 The single line synopsis">
<link href="ch-binary.html#s-extendeddesc" rel="subsection" title="3.4.2 The extended description">
<link href="ch-binary.html#s-maintscriptprompt" rel="subsection" title="3.9.1 Prompting in maintainer scripts">
<link href="ch-source.html#s-debianrules-options" rel="subsection" title="4.9.1 debian/rules and DEB_BUILD_OPTIONS">
<link href="ch-controlfields.html#s-f-Source" rel="subsection" title="5.6.1 Source">
<link href="ch-controlfields.html#s-f-Maintainer" rel="subsection" title="5.6.2 Maintainer">
<link href="ch-controlfields.html#s-f-Uploaders" rel="subsection" title="5.6.3 Uploaders">
<link href="ch-controlfields.html#s-f-Changed-By" rel="subsection" title="5.6.4 Changed-By">
<link href="ch-controlfields.html#s-f-Section" rel="subsection" title="5.6.5 Section">
<link href="ch-controlfields.html#s-f-Priority" rel="subsection" title="5.6.6 Priority">
<link href="ch-controlfields.html#s-f-Package" rel="subsection" title="5.6.7 Package">
<link href="ch-controlfields.html#s-f-Architecture" rel="subsection" title="5.6.8 Architecture">
<link href="ch-controlfields.html#s-f-Essential" rel="subsection" title="5.6.9 Essential">
<link href="ch-controlfields.html#s5.6.10" rel="subsection" title="5.6.10 Package interrelationship fields: Depends, Pre-Depends, Recommends, Suggests, Breaks, Conflicts, Provides, Replaces, Enhances">
<link href="ch-controlfields.html#s-f-Standards-Version" rel="subsection" title="5.6.11 Standards-Version">
<link href="ch-controlfields.html#s-f-Version" rel="subsection" title="5.6.12 Version">
<link href="ch-controlfields.html#s-f-Description" rel="subsection" title="5.6.13 Description">
<link href="ch-controlfields.html#s-f-Distribution" rel="subsection" title="5.6.14 Distribution">
<link href="ch-controlfields.html#s-f-Date" rel="subsection" title="5.6.15 Date">
<link href="ch-controlfields.html#s-f-Format" rel="subsection" title="5.6.16 Format">
<link href="ch-controlfields.html#s-f-Urgency" rel="subsection" title="5.6.17 Urgency">
<link href="ch-controlfields.html#s-f-Changes" rel="subsection" title="5.6.18 Changes">
<link href="ch-controlfields.html#s-f-Binary" rel="subsection" title="5.6.19 Binary">
<link href="ch-controlfields.html#s-f-Installed-Size" rel="subsection" title="5.6.20 Installed-Size">
<link href="ch-controlfields.html#s-f-Files" rel="subsection" title="5.6.21 Files">
<link href="ch-controlfields.html#s-f-Closes" rel="subsection" title="5.6.22 Closes">
<link href="ch-controlfields.html#s-f-Homepage" rel="subsection" title="5.6.23 Homepage">
<link href="ch-controlfields.html#s-f-Checksums" rel="subsection" title="5.6.24 Checksums-Sha1 and Checksums-Sha256">
<link href="ch-controlfields.html#s5.6.25" rel="subsection" title="5.6.25 DM-Upload-Allowed">
<link href="ch-controlfields.html#s-f-VCS-fields" rel="subsection" title="5.6.26 Version Control System (VCS) fields">
<link href="ch-controlfields.html#s-f-Package-List" rel="subsection" title="5.6.27 Package-List">
<link href="ch-controlfields.html#s-f-Package-Type" rel="subsection" title="5.6.28 Package-Type">
<link href="ch-controlfields.html#s-f-Dgit" rel="subsection" title="5.6.29 Dgit">
<link href="ch-controlfields.html#s-f-DM-Upload-Allowed" rel="subsection" title="5.8.1 DM-Upload-Allowed">
<link href="ch-relationships.html#s7.6.1" rel="subsection" title="7.6.1 Overwriting files in other packages">
<link href="ch-relationships.html#s7.6.2" rel="subsection" title="7.6.2 Replacing whole packages, forcing their removal">
<link href="ch-sharedlibs.html#s-ldconfig" rel="subsection" title="8.1.1 ldconfig">
<link href="ch-sharedlibs.html#s-dpkg-shlibdeps" rel="subsection" title="8.6.1 Generating dependencies on shared libraries">
<link href="ch-sharedlibs.html#s-sharedlibs-updates" rel="subsection" title="8.6.2 Shared library ABI changes">
<link href="ch-sharedlibs.html#s-sharedlibs-symbols" rel="subsection" title="8.6.3 The symbols system">
<link href="ch-sharedlibs.html#s-symbols-paths" rel="subsection" title="8.6.3.1 The symbols files present on the system">
<link href="ch-sharedlibs.html#s-symbols" rel="subsection" title="8.6.3.2 The symbols File Format">
<link href="ch-sharedlibs.html#s-providing-symbols" rel="subsection" title="8.6.3.3 Providing a symbols file">
<link href="ch-sharedlibs.html#s-sharedlibs-shlibdeps" rel="subsection" title="8.6.4 The shlibs system">
<link href="ch-sharedlibs.html#s-shlibs-paths" rel="subsection" title="8.6.4.1 The shlibs files present on the system">
<link href="ch-sharedlibs.html#s-shlibs" rel="subsection" title="8.6.4.2 The shlibs File Format">
<link href="ch-sharedlibs.html#s8.6.4.3" rel="subsection" title="8.6.4.3 Providing a shlibs file">
<link href="ch-opersys.html#s-fhs" rel="subsection" title="9.1.1 File System Structure">
<link href="ch-opersys.html#s9.1.2" rel="subsection" title="9.1.2 Site-specific programs">
<link href="ch-opersys.html#s9.1.3" rel="subsection" title="9.1.3 The system-wide mail directory">
<link href="ch-opersys.html#s-fhs-run" rel="subsection" title="9.1.4 /run and /run/lock">
<link href="ch-opersys.html#s9.2.1" rel="subsection" title="9.2.1 Introduction">
<link href="ch-opersys.html#s9.2.2" rel="subsection" title="9.2.2 UID and GID classes">
<link href="ch-opersys.html#s-/etc/init.d" rel="subsection" title="9.3.1 Introduction">
<link href="ch-opersys.html#s-writing-init" rel="subsection" title="9.3.2 Writing the scripts">
<link href="ch-opersys.html#s9.3.3" rel="subsection" title="9.3.3 Interfacing with the initscript system">
<link href="ch-opersys.html#s9.3.3.1" rel="subsection" title="9.3.3.1 Managing the links">
<link href="ch-opersys.html#s9.3.3.2" rel="subsection" title="9.3.3.2 Running initscripts">
<link href="ch-opersys.html#s9.3.4" rel="subsection" title="9.3.4 Boot-time initialization">
<link href="ch-opersys.html#s9.3.5" rel="subsection" title="9.3.5 Example">
<link href="ch-opersys.html#s-cron-files" rel="subsection" title="9.5.1 Cron job file names">
<link href="ch-opersys.html#s-media-types-freedesktop" rel="subsection" title="9.7.1 Registration of media type handlers with desktop entries">
<link href="ch-opersys.html#s-mailcap" rel="subsection" title="9.7.2 Registration of media type handlers with mailcap entries">
<link href="ch-opersys.html#s-file-media-type" rel="subsection" title="9.7.3 Providing media types to files">
<link href="ch-opersys.html#s-upstart" rel="subsection" title="9.11.1 Event-based boot with upstart">
<link href="ch-files.html#s10.7.1" rel="subsection" title="10.7.1 Definitions">
<link href="ch-files.html#s10.7.2" rel="subsection" title="10.7.2 Location">
<link href="ch-files.html#s10.7.3" rel="subsection" title="10.7.3 Behavior">
<link href="ch-files.html#s10.7.4" rel="subsection" title="10.7.4 Sharing configuration files">
<link href="ch-files.html#s10.7.5" rel="subsection" title="10.7.5 User configuration files (&quot;dotfiles&quot;)">
<link href="ch-files.html#s10.9.1" rel="subsection" title="10.9.1 The use of dpkg-statoverride">
<link href="ch-customized-programs.html#s-arch-wildcard-spec" rel="subsection" title="11.1.1 Architecture wildcards">
<link href="ch-customized-programs.html#s11.8.1" rel="subsection" title="11.8.1 Providing X support and package priorities">
<link href="ch-customized-programs.html#s11.8.2" rel="subsection" title="11.8.2 Packages providing an X server">
<link href="ch-customized-programs.html#s11.8.3" rel="subsection" title="11.8.3 Packages providing a terminal emulator">
<link href="ch-customized-programs.html#s11.8.4" rel="subsection" title="11.8.4 Packages providing a window manager">
<link href="ch-customized-programs.html#s11.8.5" rel="subsection" title="11.8.5 Packages providing fonts">
<link href="ch-customized-programs.html#s-appdefaults" rel="subsection" title="11.8.6 Application defaults files">
<link href="ch-customized-programs.html#s11.8.7" rel="subsection" title="11.8.7 Installation directory issues">
<link href="ch-docs.html#s-copyrightformat" rel="subsection" title="12.5.1 Machine-readable copyright information">
<link href="ap-pkg-sourcepkg.html#s-pkg-dpkg-source" rel="subsection" title="C.1.1 dpkg-source - packs and unpacks Debian source packages">
<link href="ap-pkg-sourcepkg.html#s-pkg-dpkg-buildpackage" rel="subsection" title="C.1.2 dpkg-buildpackage - overall package-building control script">
<link href="ap-pkg-sourcepkg.html#s-pkg-dpkg-gencontrol" rel="subsection" title="C.1.3 dpkg-gencontrol - generates binary package control files">
<link href="ap-pkg-sourcepkg.html#s-pkg-dpkg-shlibdeps" rel="subsection" title="C.1.4 dpkg-shlibdeps - calculates shared library dependencies">
<link href="ap-pkg-sourcepkg.html#s-pkg-dpkg-distaddfile" rel="subsection" title="C.1.5 dpkg-distaddfile - adds a file to debian/files">
<link href="ap-pkg-sourcepkg.html#s-pkg-dpkg-genchanges" rel="subsection" title="C.1.6 dpkg-genchanges - generates a .changes upload control file">
<link href="ap-pkg-sourcepkg.html#s-pkg-dpkg-parsechangelog" rel="subsection" title="C.1.7 dpkg-parsechangelog - produces parsed representation of a changelog">
<link href="ap-pkg-sourcepkg.html#s-pkg-dpkg-architecture" rel="subsection" title="C.1.8 dpkg-architecture - information about the build and host system">
<link href="ap-pkg-sourcepkg.html#s-pkg-debianrules" rel="subsection" title="C.2.1 debian/rules - the main building script">
<link href="ap-pkg-sourcepkg.html#s-pkg-srcsubstvars" rel="subsection" title="C.2.2 debian/substvars and variable substitutions">
<link href="ap-pkg-sourcepkg.html#sC.2.3" rel="subsection" title="C.2.3 debian/files">
<link href="ap-pkg-sourcepkg.html#sC.2.4" rel="subsection" title="C.2.4 debian/tmp">
<link href="ap-pkg-sourcepkg.html#sC.4.1" rel="subsection" title="C.4.1 Restrictions on objects in source packages">
<link href="ap-pkg-controlfields.html#s-pkg-f-Filename" rel="subsection" title="D.2.1 Filename and MSDOS-Filename">
<link href="ap-pkg-controlfields.html#s-pkg-f-Size" rel="subsection" title="D.2.2 Size and MD5sum">
<link href="ap-pkg-controlfields.html#s-pkg-f-Status" rel="subsection" title="D.2.3 Status">
<link href="ap-pkg-controlfields.html#s-pkg-f-Config-Version" rel="subsection" title="D.2.4 Config-Version">
<link href="ap-pkg-controlfields.html#s-pkg-f-Conffiles" rel="subsection" title="D.2.5 Conffiles">
<link href="ap-pkg-controlfields.html#sD.2.6" rel="subsection" title="D.2.6 Obsolete fields">

</head>

<body>

<hr>

<h1>
Debian Policy Manual
<br>Footnotes</h1>

<h2><a href="ch-scope.html#fr1" name="f1">1</a></h2>

<p>
Informally, the criteria used for inclusion is that the material meet one of
the following requirements:
</p>
<dl>
<dt>Standard interfaces</dt>
<dd>
<p>
The material presented represents an interface to the packaging system that is
mandated for use, and is used by, a significant number of packages, and
therefore should not be changed without peer review.  Package maintainers can
then rely on this interface not changing, and the package management software
authors need to ensure compatibility with this interface definition.  (Control
file and changelog file formats are examples.)
</p>
</dd>
<dt>Chosen Convention</dt>
<dd>
<p>
If there are a number of technically viable choices that can be made, but one
needs to select one of these options for inter-operability.  The version number
format is one example.
</p>
</dd>
</dl>

<p>
Please note that these are not mutually exclusive; selected conventions often
become parts of standard interfaces.
</p>

<h2><a href="ch-scope.html#fr2" name="f2">2</a></h2>

<p>
Compare RFC 2119.  Note, however, that these words are used in a different way
in this document.
</p>

<h2><a href="ch-archive.html#fr3" name="f3">3</a></h2>

<p>
The Debian archive software uses the term &quot;component&quot; internally and
in the Release file format to refer to the division of an archive.  The Debian
Social Contract simply refers to &quot;areas.&quot; This document uses
terminology similar to the Social Contract.
</p>

<h2><a href="ch-archive.html#fr4" name="f4">4</a></h2>

<p>
See <code><a href="http://www.debian.org/intro/free">What Does Free
Mean?</a></code> for more about what we mean by free software.
</p>

<h2><a href="ch-archive.html#fr5" name="f5">5</a></h2>

<p>
It is possible that there are policy requirements which the package is unable
to meet, for example, if the source is unavailable.  These situations will need
to be handled on a case-by-case basis.
</p>

<h2><a href="ch-archive.html#fr6" name="f6">6</a></h2>

<p>
This is an important criterion because we are trying to produce, amongst other
things, a free Unix.
</p>

<h2><a href="ch-binary.html#fr7" name="f7">7</a></h2>

<p>
A sample implementation of such a whitelist written for the Mailman mailing
list management software is used for mailing lists hosted by alioth.debian.org.
</p>

<h2><a href="ch-binary.html#fr8" name="f8">8</a></h2>

<p>
The detailed procedure for gracefully orphaning a package can be found in the
Debian Developer's Reference (see <a href="ch-scope.html#s-related">Related
documents, Section 1.4</a>).
</p>

<h2><a href="ch-binary.html#fr9" name="f9">9</a></h2>

<p>
The blurb that comes with a program in its announcements and/or
<code>README</code> files is rarely suitable for use in a description.  It is
usually aimed at people who are already in the community where the package is
used.
</p>

<h2><a href="ch-binary.html#fr10" name="f10">10</a></h2>

<p>
Essential is needed in part to avoid unresolvable dependency loops on upgrade.
If packages add unnecessary dependencies on packages in this set, the chances
that there <strong>will</strong> be an unresolvable dependency loop caused by
forcing these Essential packages to be configured first before they need to be
is greatly increased.  It also increases the chances that frontends will be
unable to <strong>calculate</strong> an upgrade path, even if one exists.
</p>

<p>
Also, functionality is rarely ever removed from the Essential set, but
<em>packages</em> have been removed from the Essential set when the
functionality moved to a different package.  So depending on these packages
<em>just in case</em> they stop being essential does way more harm than good.
</p>

<h2><a href="ch-binary.html#fr11" name="f11">11</a></h2>

<p>
<code>Debconf</code> or another tool that implements the Debian Configuration
Management Specification will also be installed, and any versioned dependencies
on it will be satisfied before preconfiguration begins.
</p>

<h2><a href="ch-source.html#fr12" name="f12">12</a></h2>

<p>
See the file <code>upgrading-checklist</code> for information about policy
which has changed between different versions of this document.
</p>

<h2><a href="ch-source.html#fr13" name="f13">13</a></h2>

<p>
Rationale:
</p>
<ul>
<li>
<p>
This allows maintaining the list separately from the policy documents (the list
does not need the kind of control that the policy documents do).
</p>
</li>
<li>
<p>
Having a separate package allows one to install the build-essential packages on
a machine, as well as allowing other packages such as tasks to require
installation of the build-essential packages using the depends relation.
</p>
</li>
<li>
<p>
The separate package allows bug reports against the list to be categorized
separately from the policy management process in the BTS.
</p>
</li>
</ul>

<h2><a href="ch-source.html#fr14" name="f14">14</a></h2>

<p>
The reason for this is that dependencies change, and you should list all those
packages, and <em>only</em> those packages that <em>you</em> need directly.
What others need is their business.  For example, if you only link against
<code>libimlib</code>, you will need to build-depend on
<code>libimlib2-dev</code> but not against any <samp>libjpeg*</samp> packages,
even though <samp>libimlib2-dev</samp> currently depends on them: installation
of <code>libimlib2-dev</code> will automatically ensure that all of its
run-time dependencies are satisfied.
</p>

<h2><a href="ch-source.html#fr15" name="f15">15</a></h2>

<p>
Mistakes in changelogs are usually best rectified by making a new changelog
entry rather than &quot;rewriting history&quot; by editing old changelog
entries.
</p>

<h2><a href="ch-source.html#fr16" name="f16">16</a></h2>

<p>
Although there is nothing stopping an author who is also the Debian maintainer
from using this changelog for all their changes, it will have to be renamed if
the Debian and upstream maintainers become different people.  In such a case,
however, it might be better to maintain the package as a non-native package.
</p>

<h2><a href="ch-source.html#fr17" name="f17">17</a></h2>

<p>
To be precise, the string should match the following Perl regular expression:
</p>

<pre>
     /closes:\s*(?:bug)?\#?\s?\d+(?:,\s*(?:bug)?\#?\s?\d+)*/i
</pre>

<p>
Then all of the bug numbers listed will be closed by the archive maintenance
software (<code>dak</code>) using the <var>version</var> of the changelog
entry.
</p>

<h2><a href="ch-source.html#fr18" name="f18">18</a></h2>

<p>
In the case of a sponsored upload, the uploader signs the files, but the
changelog maintainer name and address are those of the person who prepared this
release.  If the preparer of the release is not one of the usual maintainers of
the package (as listed in the <a
href="ch-controlfields.html#s-f-Maintainer"><samp>Maintainer</samp></a> or <a
href="ch-controlfields.html#s-f-Uploaders"><samp>Uploaders</samp></a> control
fields of the package), the first line of the changelog is conventionally used
to explain why a non-maintainer is uploading the package.  The Debian
Developer's Reference (see <a href="ch-scope.html#s-related">Related documents,
Section 1.4</a>) documents the conventions used.
</p>

<h2><a href="ch-source.html#fr19" name="f19">19</a></h2>

<p>
This is the same as the format generated by <samp>date -R</samp>.
</p>

<h2><a href="ch-source.html#fr20" name="f20">20</a></h2>

<p>
The rationale is that there is some information conveyed by knowing the age of
the file, for example, you could recognize that some documentation is very old
by looking at the modification time, so it would be nice if the modification
time of the upstream source would be preserved.
</p>

<h2><a href="ch-source.html#fr21" name="f21">21</a></h2>

<p>
This is not currently detected when building source packages, but only when
extracting them.
</p>

<p>
Hard links may be permitted at some point in the future, but would require a
fair amount of work.
</p>

<h2><a href="ch-source.html#fr22" name="f22">22</a></h2>

<p>
Setgid directories are allowed.
</p>

<h2><a href="ch-source.html#fr23" name="f23">23</a></h2>

<p>
Another common way to do this is for <samp>build</samp> to depend on
<code>build-stamp</code> and to do nothing else, and for the
<code>build-stamp</code> target to do the building and to <samp>touch
build-stamp</samp> on completion.  This is especially useful if the build
routine creates a file or directory called <samp>build</samp>; in such a case,
<samp>build</samp> will need to be listed as a phony target (i.e., as a
dependency of the <samp>.PHONY</samp> target).  See the documentation of
<code>make</code> for more information on phony targets.
</p>

<h2><a href="ch-source.html#fr24" name="f24">24</a></h2>

<p>
This split allows binary-only builds to not install the dependencies required
for the <samp>build-indep</samp> target and skip any resource-intensive build
tasks that are only required when building architecture-independent binary
packages.
</p>

<h2><a href="ch-source.html#fr25" name="f25">25</a></h2>

<p>
The <code>fakeroot</code> package often allows one to build a package correctly
even without being root.
</p>

<h2><a href="ch-source.html#fr26" name="f26">26</a></h2>

<p>
Some packages support any delimiter, but whitespace is the easiest to parse
inside a makefile and avoids ambiguity with flag values that contain commas.
</p>

<h2><a href="ch-source.html#fr27" name="f27">27</a></h2>

<p>
Packages built with <samp>make</samp> can often implement this by passing the
<samp>-j</samp><var>n</var> option to <samp>make</samp>.
</p>

<h2><a href="ch-source.html#fr28" name="f28">28</a></h2>

<p>
<code>files.new</code> is used as a temporary file by
<code>dpkg-gencontrol</code> and <code>dpkg-distaddfile</code> - they write a
new version of <samp>files</samp> here before renaming it, to avoid leaving a
corrupted copy if an error occurs.
</p>

<h2><a href="ch-source.html#fr29" name="f29">29</a></h2>

<p>
For example, parts of the GNU build system work like this.
</p>

<h2><a href="ch-source.html#fr30" name="f30">30</a></h2>

<p>
Having multiple copies of the same code in Debian is inefficient, often creates
either static linking or shared library conflicts, and, most importantly,
increases the difficulty of handling security vulnerabilities in the duplicated
code.
</p>

<h2><a href="ch-controlfields.html#fr31" name="f31">31</a></h2>

<hr>

<p>
<code>dpkg</code>'s internal databases are in a similar format.
</p>

<h2><a href="ch-controlfields.html#fr32" name="f32">32</a></h2>

<p>
The paragraphs are also sometimes referred to as stanzas.
</p>

<h2><a href="ch-controlfields.html#fr33" name="f33">33</a></h2>

<p>
This folding method is similar to RFC 5322, allowing control files that contain
only one paragraph and no multiline fields to be read by parsers written for
RFC 5322.
</p>

<h2><a href="ch-controlfields.html#fr34" name="f34">34</a></h2>

<p>
It is customary to leave a space after the package name if a version number is
specified.
</p>

<h2><a href="ch-controlfields.html#fr35" name="f35">35</a></h2>

<p>
In the past, people specified the full version number in the Standards-Version
field, for example &quot;2.3.0.0&quot;.  Since minor patch-level changes don't
introduce new policy, it was thought it would be better to relax policy and
only require the first 3 components to be specified, in this example
&quot;2.3.0&quot;.  All four components may still be used if someone wishes to
do so.
</p>

<h2><a href="ch-controlfields.html#fr36" name="f36">36</a></h2>

<p>
Alphanumerics are <samp>A-Za-z0-9</samp> only.
</p>

<h2><a href="ch-controlfields.html#fr37" name="f37">37</a></h2>

<p>
One common use of <samp>~</samp> is for upstream pre-releases.  For example,
<samp>1.0~beta1~svn1245</samp> sorts earlier than <samp>1.0~beta1</samp>, which
sorts earlier than <samp>1.0</samp>.
</p>

<h2><a href="ch-controlfields.html#fr38" name="f38">38</a></h2>

<p>
The author of this manual has heard of a package whose versions went
<samp>1.1</samp>, <samp>1.2</samp>, <samp>1.3</samp>, <samp>1</samp>,
<samp>2.1</samp>, <samp>2.2</samp>, <samp>2</samp> and so forth.
</p>

<h2><a href="ch-controlfields.html#fr39" name="f39">39</a></h2>

<p>
Completely empty lines will not be rendered as blank lines.  Instead, they will
cause the parser to think you're starting a whole new record in the control
file, and will therefore likely abort with an error.
</p>

<h2><a href="ch-controlfields.html#fr40" name="f40">40</a></h2>

<p>
Example distribution names in the Debian archive used in <code>.changes</code>
files are:
</p>
<dl>
<dt><em>unstable</em></dt>
<dd>
<p>
This distribution value refers to the <em>developmental</em> part of the Debian
distribution tree.  Most new packages, new upstream versions of packages and
bug fixes go into the <em>unstable</em> directory tree.
</p>
</dd>
<dt><em>experimental</em></dt>
<dd>
<p>
The packages with this distribution value are deemed by their maintainers to be
high risk.  Oftentimes they represent early beta or developmental packages from
various sources that the maintainers want people to try, but are not ready to
be a part of the other parts of the Debian distribution tree.
</p>
</dd>
</dl>

<p>
Others are used for updating stable releases or for security uploads.  More
information is available in the Debian Developer's Reference, section &quot;The
Debian archive&quot;.
</p>

<h2><a href="ch-controlfields.html#fr41" name="f41">41</a></h2>

<p>
The source formats currently supported by the Debian archive software are
<samp>1.0</samp>, <samp>3.0 (native)</samp>, and <samp>3.0 (quilt)</samp>.
</p>

<h2><a href="ch-controlfields.html#fr42" name="f42">42</a></h2>

<p>
Other urgency values are supported with configuration changes in the archive
software but are not used in Debian.  The urgency affects how quickly a package
will be considered for inclusion into the <samp>testing</samp> distribution and
gives an indication of the importance of any fixes included in the upload.
<samp>Emergency</samp> and <samp>critical</samp> are treated as synonymous.
</p>

<h2><a href="ch-controlfields.html#fr43" name="f43">43</a></h2>

<p>
A space after each comma is conventional.
</p>

<h2><a href="ch-controlfields.html#fr44" name="f44">44</a></h2>

<p>
That is, the parts which are not the <samp>.dsc</samp>.
</p>

<h2><a href="ch-maintainerscripts.html#fr45" name="f45">45</a></h2>

<p>
This is so that if an error occurs, the user interrupts <code>dpkg</code> or
some other unforeseen circumstance happens you don't leave the user with a
badly-broken package when <code>dpkg</code> attempts to repeat the action.
</p>

<h2><a href="ch-maintainerscripts.html#fr46" name="f46">46</a></h2>

<p>
This can happen if the new version of the package no longer pre-depends on a
package that had been partially upgraded.
</p>

<h2><a href="ch-maintainerscripts.html#fr47" name="f47">47</a></h2>

<p>
For example, suppose packages foo and bar are &quot;Installed&quot; with foo
depending on bar.  If an upgrade of bar were started and then aborted, and then
an attempt to remove foo failed because its <code>prerm</code> script failed,
foo's <samp>postinst abort-remove</samp> would be called with bar only
&quot;Half-Installed&quot;.
</p>

<h2><a href="ch-maintainerscripts.html#fr48" name="f48">48</a></h2>

<p>
This is often done by checking whether the command or facility the
<code>postrm</code> intends to call is available before calling it.  For
example:
</p>

<pre>
     if [ &quot;$1&quot; = purge ] &amp;&amp; [ -e /usr/share/debconf/confmodule ]; then
             . /usr/share/debconf/confmodule
             db_purge
     fi
</pre>

<p>
in <code>postrm</code> purges the <code>debconf</code> configuration for the
package if <code>debconf</code> is installed.
</p>

<h2><a href="ch-maintainerscripts.html#fr49" name="f49">49</a></h2>

<p>
Part of the problem is due to what is arguably a bug in <code>dpkg</code>.
</p>

<h2><a href="ch-maintainerscripts.html#fr50" name="f50">50</a></h2>

<p>
Historical note: Truly ancient (pre-1997) versions of <code>dpkg</code> passed
<samp>&lt;unknown&gt;</samp> (including the angle brackets) in this case.  Even
older ones did not pass a second argument at all, under any circumstance.  Note
that upgrades using such an old dpkg version are unlikely to work for other
reasons, even if this old argument behavior is handled by your postinst script.
</p>

<h2><a href="ch-relationships.html#fr51" name="f51">51</a></h2>

<p>
This approach makes dependency resolution easier.  If two packages A and B are
being upgraded, the installed package A depends on exactly the installed
package B, and the new package A depends on exactly the new package B (a common
situation when upgrading shared libraries and their corresponding development
packages), satisfying the dependencies at every stage of the upgrade would be
impossible.  This relaxed restriction means that both new packages can be
unpacked together and then configured in their dependency order.
</p>

<h2><a href="ch-relationships.html#fr52" name="f52">52</a></h2>

<p>
It is possible that a future release of <code>dpkg</code> may add the ability
to specify a version number for each virtual package it provides.  This feature
is not yet present, however, and is expected to be used only infrequently.
</p>

<h2><a href="ch-relationships.html#fr53" name="f53">53</a></h2>

<p>
To see why <samp>Breaks</samp> is normally needed in addition to
<samp>Replaces</samp>, consider the case of a file in the package
<code>foo</code> being taken over by the package <code>foo-data</code>.
<samp>Replaces</samp> will allow <code>foo-data</code> to be installed and take
over that file.  However, without <samp>Breaks</samp>, nothing requires
<code>foo</code> to be upgraded to a newer version that knows it does not
include that file and instead depends on <code>foo-data</code>.  Nothing would
prevent the new <code>foo-data</code> package from being installed and then
removed, removing the file that it took over from <code>foo</code>.  After that
operation, the package manager would think the system was in a consistent
state, but the <code>foo</code> package would be missing one of its files.
</p>

<h2><a href="ch-relationships.html#fr54" name="f54">54</a></h2>

<p>
Replaces is a one way relationship.  You have to install the replacing package
after the replaced package.
</p>

<h2><a href="ch-relationships.html#fr55" name="f55">55</a></h2>

<p>
There is no Build-Depends-Arch; this role is essentially met with
Build-Depends.  Anyone building the <samp>build-indep</samp> and
<samp>binary-indep</samp> targets is assumed to be building the whole package,
and therefore installation of all build dependencies is required.
</p>

<p>
The autobuilders use <samp>dpkg-buildpackage -B</samp>, which calls
<samp>build</samp>, not <samp>build-arch</samp> since it does not yet know how
to check for its existence, and <samp>binary-arch</samp>.  The purpose of the
original split between <samp>Build-Depends</samp> and
<samp>Build-Depends-Indep</samp> was so that the autobuilders wouldn't need to
install extra packages needed only for the binary-indep targets.  But without a
build-arch/build-indep split, this didn't work, since most of the work is done
in the build target, not in the binary target.
</p>

<h2><a href="ch-relationships.html#fr56" name="f56">56</a></h2>

<p>
<samp>Build-Depends</samp> in the source package is not adequate since it
(rightfully) does not document the exact version used in the build.
</p>

<h2><a href="ch-relationships.html#fr57" name="f57">57</a></h2>

<p>
The archive software might reject packages that refer to non-existent sources.
</p>

<h2><a href="ch-sharedlibs.html#fr58" name="f58">58</a></h2>

<p>
This is a convention of shared library versioning, but not a requirement.  Some
libraries use the <samp>SONAME</samp> as the full library file name instead and
therefore do not need a symlink.  Most, however, encode additional information
about backwards-compatible revisions as a minor version number in the file
name.  The <samp>SONAME</samp> itself only changes when binaries linked with
the earlier version of the shared library may no longer work, but the filename
may change with each release of the library.  See <a
href="#s-sharedlibs-runtime">Run-time shared libraries, Section 8.1</a> for
more information.
</p>

<h2><a href="ch-sharedlibs.html#fr59" name="f59">59</a></h2>

<p>
The package management system requires the library to be placed before the
symbolic link pointing to it in the <code>.deb</code> file.  This is so that
when <code>dpkg</code> comes to install the symlink (overwriting the previous
symlink pointing at an older version of the library), the new shared library is
already in place.  In the past, this was achieved by creating the library in
the temporary packaging directory before creating the symlink.  Unfortunately,
this was not always effective, since the building of the tar file in the
<code>.deb</code> depended on the behavior of the underlying file system.  Some
file systems (such as reiserfs) reorder the files so that the order of creation
is forgotten.  Since version 1.7.0, <code>dpkg</code> reorders the files itself
as necessary when building a package.  Thus it is no longer important to
concern oneself with the order of file creation.
</p>

<h2><a href="ch-sharedlibs.html#fr60" name="f60">60</a></h2>

<p>
These are currently <code>/usr/local/lib</code> plus directories under
<code>/lib</code> and <code>/usr/lib</code> matching the multiarch triplet for
the system architecture.
</p>

<h2><a href="ch-sharedlibs.html#fr61" name="f61">61</a></h2>

<p>
During install or upgrade, the preinst is called before the new files are
unpacked, so calling &quot;ldconfig&quot; is pointless.  The preinst of an
existing package can also be called if an upgrade fails.  However, this happens
during the critical time when a shared libs may exist on-disk under a temporary
name.  Thus, it is dangerous and forbidden by current policy to call
&quot;ldconfig&quot; at this time.
</p>

<p>
When a package is installed or upgraded, &quot;postinst configure&quot; runs
after the new files are safely on-disk.  Since it is perfectly safe to invoke
ldconfig unconditionally in a postinst, it is OK for a package to simply put
ldconfig in its postinst without checking the argument.  The postinst can also
be called to recover from a failed upgrade.  This happens before any new files
are unpacked, so there is no reason to call &quot;ldconfig&quot; at this point.
</p>

<p>
For a package that is being removed, prerm is called with all the files intact,
so calling ldconfig is useless.  The other calls to &quot;prerm&quot; happen in
the case of upgrade at a time when all the files of the old package are
on-disk, so again calling &quot;ldconfig&quot; is pointless.
</p>

<p>
postrm, on the other hand, is called with the &quot;remove&quot; argument just
after the files are removed, so this is the proper time to call
&quot;ldconfig&quot; to notify the system of the fact that the shared libraries
from the package are removed.  The postrm can be called at several other times.
At the time of &quot;postrm purge&quot;, &quot;postrm abort-install&quot;, or
&quot;postrm abort-upgrade&quot;, calling &quot;ldconfig&quot; is useless
because the shared lib files are not on-disk.  However, when &quot;postrm&quot;
is invoked with arguments &quot;upgrade&quot;, &quot;failed-upgrade&quot;, or
&quot;disappear&quot;, a shared lib may exist on-disk under a temporary
filename.
</p>

<h2><a href="ch-sharedlibs.html#fr62" name="f62">62</a></h2>

<p>
For example, a <code><var>package-name</var>-config</code> script or
<code>pkg-config</code> configuration files.
</p>

<h2><a href="ch-sharedlibs.html#fr63" name="f63">63</a></h2>

<p>
This wording allows the development files to be split into several packages,
such as a separate architecture-independent
<code><var>libraryname</var>-headers</code>, provided that the development
package depends on all the required additional packages.
</p>

<h2><a href="ch-sharedlibs.html#fr64" name="f64">64</a></h2>

<p>
Previously, <samp>${Source-Version}</samp> was used, but its name was confusing
and it has been deprecated since dpkg 1.13.19.
</p>

<h2><a href="ch-sharedlibs.html#fr65" name="f65">65</a></h2>

<p>
A <code>shlibs</code> file represents an SONAME as a library name and version
number, such as <samp>libfoo VERSION</samp>, instead of recording the actual
SONAME.  If the SONAME doesn't match one of the two expected formats
(<samp>libfoo-VERSION.so</samp> or <samp>libfoo.so.VERSION</samp>), it cannot
be represented.
</p>

<h2><a href="ch-sharedlibs.html#fr66" name="f66">66</a></h2>

<p>
<code>dpkg-shlibdeps</code> will use a program like <code>objdump</code> or
<code>readelf</code> to find the libraries and the symbols in those libraries
directly needed by the binaries or shared libraries in the package.
</p>

<h2><a href="ch-sharedlibs.html#fr67" name="f67">67</a></h2>

<p>
The easiest way to call <code>dpkg-shlibdeps</code> correctly is to use a
package helper framework such as <code>debhelper</code>.  If you are using
<code>debhelper</code>, the <code>dh_shlibdeps</code> program will do this work
for you.  It will also correctly handle multi-binary packages.
</p>

<h2><a href="ch-sharedlibs.html#fr68" name="f68">68</a></h2>

<p>
<code>dh_shlibdeps</code> from the <samp>debhelper</samp> suite will
automatically add this option if it knows it is processing a udeb.
</p>

<h2><a href="ch-sharedlibs.html#fr69" name="f69">69</a></h2>

<p>
Again, <code>dh_shlibdeps</code> and <code>dh_gencontrol</code> will handle
everything except the addition of the variable to the control file for you if
you're using <code>debhelper</code>, including generating separate
<code>substvars</code> files for each binary package and calling
<code>dpkg-gencontrol</code> with the appropriate flags.
</p>

<h2><a href="ch-sharedlibs.html#fr70" name="f70">70</a></h2>

<p>
A good example of where this helps is the following.  We could update
<samp>libimlib</samp> with a new version that supports a new revision of a
graphics format called dgf (but retaining the same major version number) and
depends on a new library package <code>libdgf4</code> instead of the older
<code>libdgf3</code>.  If we used <code>ldd</code> to add dependencies for
every library directly or indirectly linked with a binary, every package that
uses <samp>libimlib</samp> would need to be recompiled so it would also depend
on <code>libdgf4</code> in order to retire the older <code>libdgf3</code>
package.  Since dependencies are only added based on ELF <samp>NEEDED</samp>
attribute, packages using <samp>libimlib</samp> can rely on
<samp>libimlib</samp> itself having the dependency on an appropriate version of
<samp>libdgf</samp> and do not need rebuilding.
</p>

<h2><a href="ch-sharedlibs.html#fr71" name="f71">71</a></h2>

<p>
An example of an &quot;unreasonable&quot; program is one that uses library
interfaces that are documented as internal and unsupported.  If the only
programs or libraries affected by a change are &quot;unreasonable&quot; ones,
other techniques, such as declaring <samp>Breaks</samp> relationships with
affected packages or treating their usage of the library as bugs in those
packages, may be appropriate instead of changing the SONAME.  However, the
default approach is to change the SONAME for any change to the ABI that could
break a program.
</p>

<h2><a href="ch-sharedlibs.html#fr72" name="f72">72</a></h2>

<p>
An example may clarify.  Suppose the source package <samp>foo</samp> generates
two binary packages, <samp>libfoo2</samp> and <samp>foo-runtime</samp>.  When
building the binary packages, the contents of the packages are staged in the
directories <code>debian/libfoo2</code> and <code>debian/foo-runtime</code>
respectively.  (<code>debian/tmp</code> could be used instead of one of these.)
Since <samp>libfoo2</samp> provides the <samp>libfoo</samp> shared library, it
will contain a <samp>symbols</samp> file, which will be installed in
<code>debian/libfoo2/DEBIAN/symbols</code>, eventually to be included as a
control file in that package.  When <code>dpkg-shlibdeps</code> is run on the
executable <code>debian/foo-runtime/usr/bin/foo-prog</code>, it will examine
the <code>debian/libfoo2/DEBIAN/symbols</code> file to determine whether
<samp>foo-prog</samp>'s library dependencies are satisfied by any of the
libraries provided by <samp>libfoo2</samp>.  Since those binaries were linked
against the just-built shared library as part of the build process, the
<code>symbols</code> file for the newly-built <samp>libfoo2</samp> must take
precedence over a <code>symbols</code> file for any other <samp>libfoo2</samp>
package already installed on the system.
</p>

<h2><a href="ch-sharedlibs.html#fr73" name="f73">73</a></h2>

<p>
This can be determined by using the command
</p>
<pre>
     		  readelf -d /usr/lib/libz.so.1.2.3.4 | grep SONAME
</pre>

<h2><a href="ch-sharedlibs.html#fr74" name="f74">74</a></h2>

<p>
An example of where this may be needed is with a library that implements the
libGL interface.  All GL implementations provide the same set of base
interfaces, and then may provide some additional interfaces only used by
programs that require that specific GL implementation.  So, for example,
libgl1-mesa-glx may use the following <code>symbols</code> file:
</p>

<pre>
     		  libGL.so.1 libgl1
     		  | libgl1-mesa-glx #MINVER#
     		  publicGlSymbol@Base 6.3-1
     		  [...]
     		  implementationSpecificSymbol@Base 6.5.2-7 1
     		  [...]
</pre>

<p>
Binaries or shared libraries using only <samp>publicGlSymbol</samp> would
depend only on <samp>libgl1</samp> (which may be provided by multiple
packages), but ones using <samp>implementationSpecificSymbol</samp> would get a
dependency on <samp>libgl1-mesa-glx (&gt;= 6.5.2-7)</samp>
</p>

<h2><a href="ch-sharedlibs.html#fr75" name="f75">75</a></h2>

<p>
This field should normally not be necessary, since if the behavior of any
symbol has changed, the corresponding symbol <var>minimal-version</var> should
have been increased.  But including it makes the <samp>symbols</samp> system
more robust by tightening the dependency in cases where the package using the
shared library specifically requires at least a particular version of the
shared library development package for some reason.
</p>

<h2><a href="ch-sharedlibs.html#fr76" name="f76">76</a></h2>

<p>
If you are using <samp>debhelper</samp>, <code>dh_makeshlibs</code> will take
care of calling either <code>dpkg-gensymbols</code> or generating a
<code>shlibs</code> file as appropriate.
</p>

<h2><a href="ch-sharedlibs.html#fr77" name="f77">77</a></h2>

<p>
This is what <code>dh_makeshlibs</code> in the <code>debhelper</code> suite
does.  If your package also has a udeb that provides a shared library,
<code>dh_makeshlibs</code> can automatically generate the <samp>udeb:</samp>
lines if you specify the name of the udeb with the <samp>--add-udeb</samp>
option.
</p>

<h2><a href="ch-opersys.html#fr78" name="f78">78</a></h2>

<p>
This is necessary in order to reserve the directories for use in
cross-installation of library packages from other architectures, as part of
<samp>multiarch</samp>.
</p>

<h2><a href="ch-opersys.html#fr79" name="f79">79</a></h2>

<p>
This is necessary for architecture-dependant headers file to coexist in a
<samp>multiarch</samp> setup.
</p>

<h2><a href="ch-opersys.html#fr80" name="f80">80</a></h2>

<p>
This directory is used as mount point to mount virtual filesystems to get
access to kernel information.
</p>

<h2><a href="ch-opersys.html#fr81" name="f81">81</a></h2>

<p>
These directories are used to store translators and as a set of standard names
for mount points, respectively.
</p>

<h2><a href="ch-opersys.html#fr82" name="f82">82</a></h2>

<p>
<samp>/lib/lsb/init-functions</samp>, which assists in writing LSB-compliant
init scripts, may fail if <samp>set -e</samp> is in effect and echoing status
messages to the console fails, for example.
</p>

<h2><a href="ch-opersys.html#fr83" name="f83">83</a></h2>

<p>
Creating, modifying or removing a file in <code>/usr/lib/mime/packages/</code>
using maintainer scripts will not activate the trigger.  In that case, it can
be done by calling <samp>dpkg-trigger --no-await /usr/lib/mime/packages</samp>
from the maintainer script after creating, modifying, or removing the file.
</p>

<h2><a href="ch-files.html#fr84" name="f84">84</a></h2>

<p>
If you are using GCC, <samp>-fPIC</samp> produces code with relocatable
position independent code, which is required for most architectures to create a
shared library, with i386 and perhaps some others where non position
independent code is permitted in a shared library.
</p>

<p>
Position independent code may have a performance penalty, especially on
<samp>i386</samp>.  However, in most cases the speed penalty must be measured
against the memory wasted on the few architectures where non position
independent code is even possible.
</p>

<h2><a href="ch-files.html#fr85" name="f85">85</a></h2>

<p>
Some of the reasons why this might be required is if the library contains hand
crafted assembly code that is not relocatable, the speed penalty is excessive
for compute intensive libs, and similar reasons.
</p>

<h2><a href="ch-files.html#fr86" name="f86">86</a></h2>

<p>
Some of the reasons for linking static libraries with the <samp>-fPIC</samp>
flag are if, for example, one needs a Perl API for a library that is under
rapid development, and has an unstable API, so shared libraries are pointless
at this phase of the library's development.  In that case, since Perl needs a
library with relocatable code, it may make sense to create a static library
with relocatable code.  Another reason cited is if you are distilling various
libraries into a common shared library, like <samp>mklibs</samp> does in the
Debian installer project.
</p>

<h2><a href="ch-files.html#fr87" name="f87">87</a></h2>

<p>
You might also want to use the options <samp>--remove-section=.comment</samp>
and <samp>--remove-section=.note</samp> on both shared libraries and
executables, and <samp>--strip-debug</samp> on static libraries.
</p>

<h2><a href="ch-files.html#fr88" name="f88">88</a></h2>

<p>
A common example are the so-called &quot;plug-ins&quot;, internal shared
objects that are dynamically loaded by programs using <code>dlopen(3)</code>.
</p>

<h2><a href="ch-files.html#fr89" name="f89">89</a></h2>

<p>
These files store, among other things, all libraries on which that shared
library depends.  Unfortunately, if the <code>.la</code> file is present and
contains that dependency information, using <code>libtool</code> when linking
against that library will cause the resulting program or library to be linked
against those dependencies as well, even if this is unnecessary.  This can
create unneeded dependencies on shared library packages that would otherwise be
hidden behind the library ABI, and can make library transitions to new SONAMEs
unnecessarily complicated and difficult to manage.
</p>

<h2><a href="ch-files.html#fr90" name="f90">90</a></h2>

<p>
Single UNIX Specification, version 3, which is also IEEE 1003.1-2004 (POSIX),
and is available on the World Wide Web from <code><a
href="http://www.unix.org/version3/online.html">The Open Group</a></code> after
free registration.
</p>

<h2><a href="ch-files.html#fr91" name="f91">91</a></h2>

<p>
These features are in widespread use in the Linux community and are implemented
in all of bash, dash, and ksh, the most common shells users may wish to use as
<code>/bin/sh</code>.
</p>

<h2><a href="ch-files.html#fr92" name="f92">92</a></h2>

<p>
This is necessary to allow top-level directories to be symlinks.  If linking
<code>/var/run</code> to <code>/run</code> were done with the relative symbolic
link <code>../run</code>, but <code>/var</code> were a symbolic link to
<code>/srv/disk1</code>, the symbolic link would point to <code>/srv/run</code>
rather than the intended target.
</p>

<h2><a href="ch-files.html#fr93" name="f93">93</a></h2>

<p>
This notification could be done via a (low-priority) debconf message, or an
echo (printf) statement.
</p>

<h2><a href="ch-files.html#fr94" name="f94">94</a></h2>

<p>
It's better to use <code>mkfifo</code> rather than <code>mknod</code> to create
named pipes so that automated checks for packages incorrectly creating device
files with <code>mknod</code> won't have false positives.
</p>

<h2><a href="ch-files.html#fr95" name="f95">95</a></h2>

<p>
The <code>dpkg-maintscript-helper</code> tool, available from the
<code>dpkg</code> package, can help for this task.
</p>

<h2><a href="ch-files.html#fr96" name="f96">96</a></h2>

<p>
Rationale: There are two problems with hard links.  The first is that some
editors break the link while editing one of the files, so that the two files
may unwittingly become unlinked and different.  The second is that
<code>dpkg</code> might break the hard link while upgrading
<samp>conffile</samp>s.
</p>

<h2><a href="ch-files.html#fr97" name="f97">97</a></h2>

<p>
The traditional approach to log files has been to set up <em>ad hoc</em> log
rotation schemes using simple shell scripts and cron.  While this approach is
highly customizable, it requires quite a lot of sysadmin work.  Even though the
original Debian system helped a little by automatically installing a system
which can be used as a template, this was deemed not enough.
</p>

<p>
The use of <code>logrotate</code>, a program developed by Red Hat, is better,
as it centralizes log management.  It has both a configuration file
(<code>/etc/logrotate.conf</code>) and a directory where packages can drop
their individual log rotation configurations (<code>/etc/logrotate.d</code>).
</p>

<h2><a href="ch-files.html#fr98" name="f98">98</a></h2>

<p>
When a package is upgraded, and the owner or permissions of a file included in
the package has changed, dpkg arranges for the ownership and permissions to be
correctly set upon installation.  However, this does not extend to directories;
the permissions and ownership of directories already on the system does not
change on install or upgrade of packages.  This makes sense, since otherwise
common directories like <samp>/usr</samp> would always be in flux.  To
correctly change permissions of a directory the package owns, explicit action
is required, usually in the <samp>postinst</samp> script.  Care must be taken
to handle downgrades as well, in that case.
</p>

<h2><a href="ch-files.html#fr99" name="f99">99</a></h2>

<p>
Ordinary files installed by <code>dpkg</code> (as opposed to
<samp>conffile</samp>s and other similar objects) normally have their
permissions reset to the distributed permissions when the package is
reinstalled.  However, the use of <code>dpkg-statoverride</code> overrides this
default behavior.
</p>

<h2><a href="ch-customized-programs.html#fr100" name="f100">100</a></h2>

<p>
Internally, the package system normalizes the GNU triplets and the Debian
arches into Debian arch triplets (which are kind of inverted GNU triplets),
with the first component of the triplet representing the libc and ABI in use,
and then does matching against those triplets.  However, such triplets are an
internal implementation detail that should not be used by packages directly.
The libc and ABI portion is handled internally by the package system based on
the <var>os</var> and <var>cpu</var>.
</p>

<h2><a href="ch-customized-programs.html#fr101" name="f101">101</a></h2>

<p>
The Debian base system already provides an editor and a pager program.
</p>

<h2><a href="ch-customized-programs.html#fr102" name="f102">102</a></h2>

<p>
If it is not possible to establish both locks, the system shouldn't wait for
the second lock to be established, but remove the first lock, wait a (random)
time, and start over locking again.
</p>

<h2><a href="ch-customized-programs.html#fr103" name="f103">103</a></h2>

<p>
You will need to depend on <samp>liblockfile1 (&gt;&gt;1.01)</samp> to use
these functions.
</p>

<h2><a href="ch-customized-programs.html#fr104" name="f104">104</a></h2>

<p>
There are two traditional permission schemes for mail spools: mode 600 with all
mail delivery done by processes running as the destination user, or mode 660
and owned by group mail with mail delivery done by a process running as a
system user in group mail.  Historically, Debian required mode 660 mail spools
to enable the latter model, but that model has become increasingly uncommon and
the principle of least privilege indicates that mail systems that use the first
model should use permissions of 600.  If delivery to programs is permitted,
it's easier to keep the mail system secure if the delivery agent runs as the
destination user.  Debian Policy therefore permits either scheme.
</p>

<h2><a href="ch-customized-programs.html#fr105" name="f105">105</a></h2>

<p>
This implements current practice, and provides an actual policy for usage of
the <samp>xserver</samp> virtual package which appears in the virtual packages
list.  In a nutshell, X servers that interface directly with the display and
input hardware or via another subsystem (e.g., GGI) should provide
<samp>xserver</samp>.  Things like <samp>Xvfb</samp>, <samp>Xnest</samp>, and
<samp>Xprt</samp> should not.
</p>

<h2><a href="ch-customized-programs.html#fr106" name="f106">106</a></h2>

<p>
&quot;New terminal window&quot; does not necessarily mean a new top-level X
window directly parented by the window manager; it could, if the terminal
emulator application were so coded, be a new &quot;view&quot; in a
multiple-document interface (MDI).
</p>

<h2><a href="ch-customized-programs.html#fr107" name="f107">107</a></h2>

<p>
For the purposes of Debian Policy, a &quot;font for the X Window System&quot;
is one which is accessed via X protocol requests.  Fonts for the Linux console,
for PostScript renderer, or any other purpose, do not fit this definition.  Any
tool which makes such fonts available to the X Window System, however, must
abide by this font policy.
</p>

<h2><a href="ch-customized-programs.html#fr108" name="f108">108</a></h2>

<p>
This is because the X server may retrieve fonts from the local file system or
over the network from an X font server; the Debian package system is empowered
to deal only with the local file system.
</p>

<h2><a href="ch-customized-programs.html#fr109" name="f109">109</a></h2>

<p>
Note that this mechanism is not the same as using app-defaults; app-defaults
are tied to the client binary on the local file system, whereas X resources are
stored in the X server and affect all connecting clients.
</p>

<h2><a href="ch-docs.html#fr110" name="f110">110</a></h2>

<p>
It is not very hard to write a man page.  See the <code><a
href="http://www.schweikhardt.net/man_page_howto.html">Man-Page-HOWTO</a></code>,
<code>man(7)</code>, the examples created by <code>dh_make</code>, the helper
program <code>help2man</code>, or the directory
<code>/usr/share/doc/man-db/examples</code>.
</p>

<h2><a href="ch-docs.html#fr111" name="f111">111</a></h2>

<p>
Supporting this in <code>man</code> often requires unreasonable processing time
to find a manual page or to report that none exists, and moves knowledge into
man's database that would be better left in the file system.  This support is
therefore deprecated and will cease to be present in the future.
</p>

<h2><a href="ch-docs.html#fr112" name="f112">112</a></h2>

<p>
<code>man</code> will automatically detect whether UTF-8 is in use.  In future,
all manual pages will be required to use UTF-8.
</p>

<h2><a href="ch-docs.html#fr113" name="f113">113</a></h2>

<p>
At the time of writing, Chinese and Portuguese are the main languages with such
differences, so <code>pt_BR</code>, <code>zh_CN</code>, and <code>zh_TW</code>
are all allowed.
</p>

<h2><a href="ch-docs.html#fr114" name="f114">114</a></h2>

<p>
Normally, info documents are generated from Texinfo source.  To include this
information in the generated info document, if it is absent, add commands like:
</p>

<pre>
     @dircategory Individual utilities
     @direntry
     * example: (example).               An example info directory entry.
     @end direntry
</pre>

<p>
to the Texinfo source of the document and ensure that the info documents are
rebuilt from source during the package build.
</p>

<h2><a href="ch-docs.html#fr115" name="f115">115</a></h2>

<p>
The system administrator should be able to delete files in
<code>/usr/share/doc/</code> without causing any programs to break.
</p>

<h2><a href="ch-docs.html#fr116" name="f116">116</a></h2>

<p>
Please note that this does not override the section on changelog files below,
so the file <code>/usr/share/doc/<var>package</var>/changelog.Debian.gz</code>
must refer to the changelog for the current version of <var>package</var> in
question.  In practice, this means that the sources of the target and the
destination of the symlink must be the same (same source package and version).
</p>

<h2><a href="ch-docs.html#fr117" name="f117">117</a></h2>

<p>
Rationale: The important thing here is that HTML documentation should be
available from <em>some</em> binary package.
</p>

<h2><a href="ch-docs.html#fr118" name="f118">118</a></h2>

<p>
In particular, <code>/usr/share/common-licenses/Apache-2.0</code>,
<code>/usr/share/common-licenses/Artistic</code>,
<code>/usr/share/common-licenses/GPL-1</code>,
<code>/usr/share/common-licenses/GPL-2</code>,
<code>/usr/share/common-licenses/GPL-3</code>,
<code>/usr/share/common-licenses/LGPL-2</code>,
<code>/usr/share/common-licenses/LGPL-2.1</code>,
<code>/usr/share/common-licenses/LGPL-3</code>,
<code>/usr/share/common-licenses/GFDL-1.2</code>, and
<code>/usr/share/common-licenses/GFDL-1.3</code> respectively.  The University
of California BSD license is also included in <code>base-files</code> as
<code>/usr/share/common-licenses/BSD</code>, but given the brevity of this
license, its specificity to code whose copyright is held by the Regents of the
University of California, and the frequency of minor wording changes, its text
should be included in the copyright file rather than referencing this file.
</p>

<h2><a href="ch-docs.html#fr119" name="f119">119</a></h2>

<p>
Rationale: People should not have to look in places for upstream changelogs
merely because they are given different names or are distributed in HTML
format.
</p>

<h2><a href="ap-pkg-scope.html#fr120" name="f120">120</a></h2>

<p>
<code>dpkg</code> is targeted primarily at Debian, but may work on or be ported
to other systems.
</p>

<h2><a href="ap-pkg-sourcepkg.html#fr121" name="f121">121</a></h2>

<p>
This is so that the control file which is produced has the right permissions
</p>

<h2><a href="ap-pkg-sourcepkg.html#fr122" name="f122">122</a></h2>

<p>
This is not currently detected when building source packages, but only when
extracting them.
</p>

<h2><a href="ap-pkg-sourcepkg.html#fr123" name="f123">123</a></h2>

<p>
Hard links may be permitted at some point in the future, but would require a
fair amount of work.
</p>

<h2><a href="ap-pkg-sourcepkg.html#fr124" name="f124">124</a></h2>

<p>
Setgid directories are allowed.
</p>

<h2><a href="ap-pkg-sourcepkg.html#fr125" name="f125">125</a></h2>

<p>
Renaming a file is not treated specially - it is seen as the removal of the old
file (which generates a warning, but is otherwise ignored), and the creation of
the new one.
</p>

<hr>

<p>
Debian Policy Manual
</p>

<address>
version 3.9.8.0, 2016-03-30<br>
<br>
<a href="ch-scope.html#s-authors">The Debian Policy Mailing List</a><br>
<br>
</address>
<hr>

</body>

</html>

